#!/usr/bin/perl
# Vitaly Chekryzhev <13hakta@gmail.com>, 2011

use Date::Parse;

$fromdate = "05/01/2011";
$todate   = "06/01/2011";

$satellite = "behind";
$resolution = 1024;
$stepimage = 500;
$multiple_thread = 10;

$baseurl = "http://stereo-ssc.nascom.nasa.gov/browse/";
$dstdir = "images-" . $satellite;
$cachedir = "cache";
$loader = "loader.sh";
$filelist = "$dstdir/files.txt";

$fromstamp = str2time($fromdate);
$tostamp   = str2time($todate);
$curstamp  = $fromstamp;

open F, ">ex.sh";

sub getimages {
 $curdate = shift;

 @$curdate[0] = "0@$curdate[0]" if (@$curdate[0] < 10);
 @$curdate[1] = "0@$curdate[1]" if (@$curdate[1] < 10);

 $url = $baseurl . "@$curdate[2]/@$curdate[1]/@$curdate[0]/$satellite/euvi/195/$resolution/";
 $imgname = "@$curdate[2]@$curdate[1]@$curdate[0]";
 $filename = "$imgname.html";

 print F "[ -e '$cachedir/$filename' ] || wget -q -O $cachedir/$filename $url
grep ^$imgname $cachedir/$filename | cut -f 1 -d '<' | awk '{print \"wget -c $url\"\$0, \"-O $dstdir/\"\$0, \"&\"; if (NR % $multiple_thread == 0) print \"wait\" }' >>$loader
";
}

print F "mkdir $dstdir\n";
print F "rm loader.sh\n";

while ($curstamp <= $tostamp) {
 ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($curstamp);
 $year += 1900;
 $mon++;

 @cdate = ($mday, $mon, $year);
 getimages(\@cdate);

 $curstamp += 86400;
}

print F "echo >$filelist; grep -h ^2011 $cachedir/*.html | cut -f 1 -d '<' | awk '{if (NR % $stepimage == 0) print \$0}' >>$filelist\n";
print F "chmod +x $loader\n";
close F;
